App.Data.Facilities.club = {
	baseName: "club",
	genericName: null,
	jobs: {
		slut: {
			position: "Slut",
			assignment: "serve in the club",
			publicSexUse: true,
			fuckdollAccepted: false
		},
	},
	defaultJob: "slut",
	manager: {
		position: "DJ",
		assignment: "be the DJ",
		careers: ["a classical dancer", "a classical musician", "a dancer", "a house DJ", "a marching band leader", "a musician", "a radio show host", "an aspiring pop star", "an idol", "an orchestra conductor"],
		skill: "DJ",
		publicSexUse: false,
		fuckdollAccepted: false,
		broodmotherAccepted: false,
		shouldWalk: true,
		shouldSee: false,
		shouldHear: true,
		shouldTalk: true,
		shouldThink: true,
		requiredDevotion: 51
	}
}

App.Entity.Facilities.ClubSlutJob = class extends App.Entity.Facilities.FacilitySingleJob {
	/**
	 * @param {App.Entity.SlaveState} slave
	 * @returns {string[]}
	 */
	canEmploy(slave) {
		let r = super.canEmploy(slave);

		// condition is the same as for the brothel
		// TODO: consider moving this to App.Entity.Facilities.SexJob
		if (!App.Entity.Facilities.Job._isBrokenEnough(slave, 51, -50, -20, -50, 50)) {
			r.push(App.Entity.Facilities.Job._stdBreakageMessage(slave));
		}

		return r;
	}
}

App.Entity.Facilities.ClubDJJob = class extends App.Entity.Facilities.ManagingJob {
	canEmploy(slave) {
		let r = super.canEmploy(slave);
		if (slave.intelligence + slave.intelligenceImplant < -50) {
			r.push(`${slave.slaveName} is not intelligent enough to DJ.`);
		}
		return r;
	}
}

App.Entity.facilities.club = new App.Entity.Facilities.Facility(
	App.Data.Facilities.club,
	{
		slut: new App.Entity.Facilities.ClubSlutJob()
	},
	new App.Entity.Facilities.ClubDJJob()
);
